package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:压力知觉量表
 * @date 2021/7/20 15:55
 */
public class PSSScale extends BaseScale{

    public PSSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("PSSScale");
        //ScaleUtil.loadLib("PSSScale");
        //System.out.println("JSONArray:"+jsonArray);
        //System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.PSSScale(jsonArray.toString(), resultJson.toString());
        System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //压力知觉均分
        double score = 0;
        //危机知觉均分
        double score1 = 0;
        //应对能力知觉均分
        double score2 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (i == 3 || i == 4 || i == 6 || i == 7){
                    if (jsonObject1.getString("checkItems").equals("偶尔")) {
                        score2 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("有时")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("常常")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("总是")) {
                        score2 += 4;
                    }
                }else {
                    if (jsonObject1.getString("checkItems").equals("偶尔")) {
                        score1 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("有时")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("常常")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("总是")) {
                        score1 += 4;
                    }
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                if (i == 3 || i == 4 || i == 6 || i == 7){
                    if (jsonObject1.getString("checkItems").equals("偶尔")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("有时")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("常常")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("总是")) {
                        score2 += 1;
                    }
                }else {
                    if (jsonObject1.getString("checkItems").equals("偶尔")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("有时")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("常常")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("总是")) {
                        score1 += 1;
                    }
                }
            }
        }
        DecimalFormat df   = new DecimalFormat("######0.00");
        score = (score1 + score2)/10;
        score1 = score1/6;
        score2 = score2/4;
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("压力知觉均分", String.valueOf(Double.parseDouble(df.format(score))));
        resultJson.put("压力知觉均分", String.valueOf(Double.parseDouble(df.format(score))));
        if (score < 1){
            resultMap.put("压力知觉结论", "您的压力水平较低，请继续保持");
            resultJson.put("压力知觉结论", "您的压力水平较低，请继续保持");
        }else if (score >= 1 && score <2 ){
            resultMap.put("压力知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
            resultJson.put("压力知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
        }else if (score >= 2 && score <3){
            resultMap.put("压力知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
            resultJson.put("压力知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
        }else if (score >= 3){
            resultMap.put("压力知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
            resultJson.put("压力知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
        }
        resultMap.put("应对能力知觉均分", String.valueOf(Double.parseDouble(df.format(score1))));
        resultJson.put("应对能力知觉均分", String.valueOf(Double.parseDouble(df.format(score1))));
        if (score1 < 1){
            resultMap.put("应对能力知觉结论", "您的压力水平较低，请继续保持");
            resultJson.put("应对能力知觉结论", "您的压力水平较低，请继续保持");
        }else if (score1 >= 1 && score1 <2 ){
            resultMap.put("应对能力知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
            resultJson.put("应对能力知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
        }else if (score1 >= 2 && score1 <3){
            resultMap.put("应对能力知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
            resultJson.put("应对能力知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
        }else if (score1 >= 3){
            resultMap.put("应对能力知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
            resultJson.put("应对能力知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
        }
        resultMap.put("危机知觉均分", String.valueOf(Double.parseDouble(df.format(score2))));
        resultJson.put("危机知觉均分", String.valueOf(Double.parseDouble(df.format(score2))));
        if (score2 < 1){
            resultMap.put("危机知觉结论", "您的压力水平较低，请继续保持");
            resultJson.put("危机知觉结论", "您的压力水平较低，请继续保持");
        }else if (score2 >= 1 && score2 <2 ){
            resultMap.put("危机知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
            resultJson.put("危机知觉结论", "您的压力水平较低，如有必要，建议寻找合适的方法减压");
        }else if (score2 >= 2 && score2 <3){
            resultMap.put("危机知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
            resultJson.put("危机知觉结论", "您目前存在着一定的心理压力，建议寻找合适的方法进行减压，如有必要，请寻求心理咨询");
        }else if (score2 >= 3){
            resultMap.put("危机知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
            resultJson.put("危机知觉结论", "您目前的心理压力较大，一定要寻找合适的方法进行减压，推荐进行专业的心理咨询");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_PSS);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
